%% -------------------------------------------------------------------------- %%
\chapter{Discussion and Results}
\label{chap:results}

In this chapter, we present a compreensive description of the group structure:
the tools used by its members to support their activities; how the newcomer
training happens; and the general profile of FLUSP members.  We paid special
attention to the participants observed in this work, making comparisons between
their profiles as contributors. We also extend the comparison to includes
reflections of our profile as a FLUSP member and as FLOSS contributor.  At last,
an extensive study about their contributions will be performed, including an
analysis of the patches sent and of the answers provided by the members selected
to answer our questionnaire. We use those results to evidence that study groups
can be used to achieve a greater member permanence in FLOSS communities and,
thus, contribute to their subsistence.

\section{FLUSP organization and principles}

FLUSP organization follows a horizontal hierarchy, where all its members have
the same voting powers, and there is no sense of seniority. Although each
project developed under the group umbrella has at least one mentor, all
decisions are taken democratically.

FLUSP is based on a set of four
values\footnote{\url{https://flusp.ime.usp.br/about}}:

\begin{itemize}
	\item Freedom of code and knowledge;
	\item Flatness;
	\item The belief sharing is paramount to the group and valuing the
	mutual exchange of learning among members (``passing the baton'');
	\item Code reviewing as just as important as adding code.
\end{itemize}

The concept of member is still unclear in FLUSP. Despite the fact that the group
held many meetings with the intention of creating a manifesto, no such thing has
ever materialized up to this moment. Informally, though, anyone who has
participated in a couple of meetings is considered a member and, consequently,
has voting powers. Any member has the prerogative to propose the creation of a
new project.

Although being a university extension group, it is not necessary to be
affiliated to USP or any other institution of higher education to be a part of
FLUSP. FLUSP is a group of students with no affiliation to any professor,
although bureaucratically it has a professor responsible for the group
activities, Alfredo Goldman.

\subsection{The tools that support group activities}

Most information about the group is available in its official web
page\footnote{\url{https://flusp.ime.usp.br/}}, such as tutorials, its meeting
schedule and news about events. This website is developed using \textbf{Jekyll},
a static site generation tool written in Ruby. Jekyll provides an easier
experience by allowing its users to write content in Markdown and then
converting the raw text files into a static website. As FLUSP is comprised of
volunteers, its resources are mostly limited to the knowledge its members
possess. Since none of its members had much front-end web development when the
site was created, Jekyll was chosen to facilitate its generation. In this way,
the tool was able to decrease the learning curve associated with web page
development and enabled the creation of the group website.

The files related to its web page are versioned as one of the group projects
in \textbf{Gitlab}, a platform that provides a Git repository manager, along
with a wiki page and a issue-tracking tool.  Gitlab is one of the many pages on
the web that offer control versioning through Git, and was chosen by the group
for being FLOSS and for the cluster of features it provides in its free version.
Besides its website, it is also in Gitlab that all the files under the FLUSP
umbrella are stored, including the GCC mirror used by the participants who
contribute to this project. Grounded on rules that value freedom of code and
knowledge, all of the group projects on Gitlab are openly available to the
public, with the exception of its website infrastructure project. The reason
for that is because it contains critical data about the web page that the group
still has not found out how to conceal.

Regarding writing permission to their projects, any member that manifests
interest in getting involved can obtain it.  One problem that troubles the
group repositories, though, is the lack of organization pertaining on how
contributions are performed. Most of the time, pull requests concerning the
changed code are not created, and so the code is directly pushed into the master
branch. Pull requests allow a contributor to suggest changes from one branch to
be merged to another branch and are considered a good development practice,
since they make it possible for users to discuss the proposed changes and
potentially spot any existing issues on the code.

\subsection{Newcomers Training Process}

The group website provides a number of blog posts and tutorials with the aim
of helping newcomers navigate more easily through the communities' cycle of
contribution. Besides the production of materials and the group meetings, FLUSP
also promotes events to attract contributors and provide FLOSS experiences for
its members. 

On March 26th, 2019, FLUSP promoted its first event, the GNU/Linux install fest.
The FLOSS culture has a lot of force in IME, with Computer Science students
being encouraged since their first year to use the aforementioned operating
system. Many freshmen attended the install fest to have a GNU/Linux distribution
installed in their notebooks. The event was considered a success, with about
twenty installations being made that day.

In the following month FLUSP presented an introductory Git workshop. The
workshop had the goal of teaching its participants the most basic Git commands,
including how to use branches. It had around sixteen participants and was
attended mostly by freshmen.

On May 18th, 2019, ocurred FLUSP major event to date, the KernelDevDay.
KernelDevDay main goal was to help people who had never contributed to a
FLOSS project make their first contribution. The chosen project was the Linux
kernel, more specifically the Industrial Input/Output subsystem. The 21
participants were divided in nine teams and began working in the pre-selected
issues. By the end of the day, fifteen patches were submitted to IIO mailing
list, with one more having been sent afterwards. The feedback was overwhelmingly
positive, with both participants and IIO maintainers praising the event
outcome.

It was also possible to interact with many people involved in the Linux
community during two events in which FLUSP members participated: DebConf 2019
and the linuxdev-br of the same year.

We can see the meaningful impact FLUSP was able to have in the Linux IIO
subsystem. From the period of October 3rd, 2018 to November 17th, 2018, FLUSP
contributions to this subsystem represented 20\% of all the contributions sent
to its mailing list. From January 4th, 2019 to April, 4th, 2019, this scenario
happened again, since 19.4\% of the patches sent to IIO were sent by FLUSP
members.

\section{FLUSP participants on FLOSS universe}

Considering the FLUSP engagement on IIO, we observed the six participants of
FLUSP with more contributions sent to this subsystem, in addition to
contributions provided by the main author of this work. The seven participants
observed in this study were named as follows:

\begin{itemize}
	\item Participant 1 (P1): undergraduate student; %marcelo
	\item Participant 2 (P2): master student; %renato 
	\item Participant 3 (P3): undergraduate; % lucas
	\item Participant 4 (P4): undergraduate student; %matheus
	\item Participant 5 (P5): master student; %giuliano
	\item Participant 6 (P6): master stundent and co-advisor of this work; %melissa
	\item Participant 7 (P7): main author of this work. %barbara
\end{itemize}


P1, P3, P4 and P7 are undergraduate students in the final year of a Bachelor
degree in Computer Science. P2, P5, and P6 are students getting their Master
degree in the same course.  Besides participating with patches sent through
FLUSP, one member of the group - P1 - also contributed to the kernel project
through GSoC.

To complement the analysis of each profile, we sent a questionnaire to the
observed participants. P6 and P7 were the only participants that did
not answer the questionnaire, since P6 and P7 were involved in the elaboration of this
study.  According to the answers given in the questionnaire, the mean age of the
interviewees is of 24.2 years-old. 

Through the questionnaire it was also possible to get acquainted with the
development practices of each participant. P1, P2, and P5 showed to
be people who prefer to develop contributions by programming individually.
P3 and P4, on the other hand, stated a preference for programming in
pairs. P7 is also a person that has an inclination to prefer to engage in pair
programming.

\subsection{Contributions to the Linux Kernel Project}

There were sent to FLUSP mailing list a total of 277 patches. If we were to
count only the final version of the patches, this number drops to 115 - meaning
that 41.5\% of the patches sent to this list were composed of final versions.

To analyze the contributions of FLUSP participants, we collected and classified
the patches set to IIO in six different types: bug fix, code style, cover
letter, documentation, enhancement and feature. 

\begin{itemize}
    \item \textit{Bug fix} is a type of patch that intends to provide a solution
	    for an existing bug in the code.
    \item \textit{Code style} patch is one that aims to correct the writing
	    guidelines used during the composition of a program source-code.
    \item \textit{Cover letter} is created when a patch series is generated and
	    usually has a description of the series' purpose and a short
	    explanation of what each one of the patches does. Cover letters are
	    not sent as a distinct e-mail when sent to the IIO mailing list. We
	    decided not to take them into account when counting the percentages
	    of each participants' patch types.
    \item \textit{Documentation} patches are the ones pertaining the creation of
	    material with information regarding the functioning of a driver or
	    hardware. We also categorized as a documentation patch the ones with
	    the objective of writing comments in the code to explain what it
	    does.
    \item \textit{Enhancement} patches offer minor improvements to a driver
	    source code, but are not significant enough to be considered a new
	    feature. At last, a feature patch is one that provides a meaningful
	    modification to the code in a way that they can be considered a new
	    attribute per se.
\end{itemize}

We were able to categorize the patches sent by people affiliated to FLUSP as
following: 43 (37.4\%) were enhancements, 37 (32.2\%) were code style, 24
(20.9\%) were documentation, 6 (5.2\%) were features and 5 (4.3\%) were bug
fixes. The percentage of patches done together was of 32.2\%, totalizing 37
patches.

\begin{figure}[ht]
  \centering
\includegraphics[width=0.7\linewidth]{chart_patches_bytype.pdf}
\caption{Final patches by type}
\label{fig:patchesbytype}
\end{figure}

All the seven people studied had a code style patch as their first one. This is
according to the expected, because patches of this kind are considered the most
simple ones and, as such, are a good way of familiarizing new contributors with
the dynamics and contribution rules existing in the community. We also notice
that the more experienced contributors possessed less patches made together.
Creating patches along with other programmers can be seen as a way of
transmiting part of one experience to the other. Therefore, it is to be
expected that the less experienced contributors had more patches done in groups.

Additionally, it is expected that more experienced programmers have a larger
amount of accepted patches among the ones sent to the IIO mailing list, and this
scenario is exactly what happened within the collected data. Inexperience
usually entails making more mistakes, so it is natural that the programmers that
are in the community for a shorter amount of time have less patches sent to the
IIO than their counterparties.

\subsection{Becoming a Linux contributor}

It is possible to notice that most of the final patches sent to FLUSP mailing
list were also sent to IIO mailing list, since 96 (83.5\%) of the final
patches were sent there. Of all the final patches sent to the IIO, 71 (74\%)
were accepted by the list.

There were 18 final patches sent the day KernelDevDay (KDD) took place, which
represents 15.7\% of all the final patches ever sent to FLUSP mailing list.
Together these people contributed with 11 final patches, which amounts to 9.6\%
of all the final patches sent to the list. As those numbers can attest, KDD
represented a significant success to the group mission of stimulating
contributions to FLOSS projects. However, ten people that participated in this
event have not made any other contribution neither before nor after through
FLUSP mailing list. Therefore, KDD was not able to successfully insert those
participants in the Free Software community.


\begin{figure}[ht]
\centering
\begin{subfigure}{.49\textwidth}
\centering
\includegraphics[width=\linewidth]{main_author.png}
\caption{Final patches by main author}
\label{fig:main_author}
\end{subfigure}
\begin{subfigure}{.49\textwidth}
\centering
\includegraphics[width=\linewidth]{secondary_author.png}
\caption{Final patches by secondary author}
\label{fig:secondary_author}
\end{subfigure}
\caption{Final patches by authorship}
\label{fig:final_authors}
\end{figure}


Of the people studied, P1 was the one who sent most patches, with 19 patches as
the main author and none as the secondary author, totalizing 16.5\% of the
patches sent as main author. The second person with most patches was P2, with 18
patches sent as the main author and none sent as the secondary author. This
corresponds to 15.7\% of all the patches sent as the main author. The third
person with most patches is P3, with 12 patches sent as the main author and 2
sent as the secondary author, which is equal to 10.4\% of the patches sent as
the main author and 5.4\% of the patches sent as the secondary author. The
fourth and fifth people with most patches were P4 and us, the former with 5
patches sent as the main author and 5 patches sent as the secondary author
(corresponding, respectively, to 4.3\% of the patches sent as the main author
and 13.5\% of the patches sent as the secondary author) and the latter with 10
patches sent as the main author and none as the secondary author (corresponding
to 8.7\% of all the patches sent as the main author). The sixth person with most
patches was P6, who sent 6 patches as the main author and 2 as the
secondary author, which corresponds, respectively, to 5.2\% and 5.4\% of the
patches sent as main and as secondary author. The seventh person with most
patches was P5, who sent 4 patches as the main author and 2 patches as the
secondary author. This corresponds, respectively, to 3.5\% and 5.4\% of the
patches sent as the main author and secondary author. The other participants
sent in total 41 patches as the primary author (corresponding to 35.7\% of the
total) and 26 patches as the secondary author (corresponding to 70.3\% of the
total). Those numbers can be seen in Figure~\ref{fig:final_authors}.

\subsection{The diversity of contributions}

Studying the final patches sent by P1, it is possible to categorize them as
being 9 (47.4\%) of enhancements, 6 (31.6\%) of code style and 4 (21.1\%) of
documentation. In total, he sent 40 patches to FLUSP mailing list.  Of all the
final patches sent by P2, 5 (27.8\%) were of documentation, 4 (22.2\%) were of
enhancements, 3 (16.7\%) were of code style, 3 (16.7\%) were bug fixes and 3
(16.7\%) were features. In total, P2 sent 50 patches to FLUSP mailing list.

P3 sent, 8 (57.1\%) were of enhancements, 3 (21.4\%) were of documentation, 1
(7.1\%) were of code style, 1 (7.1\%) of feature and 1 (7.1\%) were of bug fix.
The member P4 developed 4 (40\%) patches of code style, 3 (30\%) of enhancements
and 2 (20\%) of documentation. He sent in a total of 22 patches to FLUSP
mailing list.

Concerning our participation, it is possible to see that 6 (60\%) of the final
patches were of code style and 4 (40\%) were of enhancements.  As for P6, 4
(50\%) of her final patches were of enhancements, 3 (37.5\%) were of code style
and 1 (12.5\%) were of documentation. P5 sent 3 (50\%) final patches of
enhancements, 2 (33.3\%) of features and 1 (16.7\%) of bug fixes. In total, he
sent 23 patches to FLUSP mailing list.

\subsection{Different profiles of contributors}

Despite being a development group, four of the seven participants observed seem
to be a person that prefer to codify their contributions alone. Of the 19
patches sent by P1, 16 (84.2\%) were developed without help from any other
person and only 3 (15.8\%) were developed with the help of another participant.
In the questionnaire, P1 justified his preference for contributing individually
by arguing that in this way he can do everything in his own time. He is one of
the members with the largest proportion of patches sent to the IIO: all of his
19 patches were sent to that mailing list. He is a contributor with a high
percentage of accepted patches, since of all the patches he sent, 15 (78.9\%)
received positive feedback and were included in the kernel code.

This characteristic also appears in the development of P2's patches, 16 (88.9\%)
of them were written without anyone else help and 2 (11.1\%) were written with
the help of one other person. In this case, with P5's. In the questionnaire, P2
justified his preference for individual contributions due to feeling he can be
more productive this way.  It is also possible to see that P2 has a large
proportion of patches sent to the IIO. Of the 18 patches he sent, all of them
(100\%) were sent to this subsystem mailing list. This can be seen as a reflex
of his experience in the group and of his abilities as a programmer. P2 also has
the highest rate of accepted patches among the ones sent to the IIO. He has 17
patches accepted and 1 rejected, which represents an acceptance rate of 94.4\%.

Two other participants who demonstrated to be more comfortable coding
individually are P6 and P5. P6 developed 6 of her final 8 patches by
herself, which represents a proportion of 75\% of them being developed without
any other person helps. Of the final patches sent by this participant, 6 (75\%)
were sent to the IIO mailing list and 2 (25\%) were not.  Of those 6, all of
them were accepted by the IIO.  She has the largest proportion of accepted
patches among the studied participants. Few of P5 final patches - 2 (33.3\%) -
were developed together with another person. In this case, with P2. P5 expressed
in the questionnaire a preference for individual contributions.  He also possess
the largest proportion of patches sent to the IIO mailing list, since all of his
6 patches were sent to it.  His percentage of final patches accepted among the
ones sent to the IIO mailing list showed to be similar to the other
participants, being of 66.7\%.

Another two observed participants and P7 seem to worry about pair-programming
and co-development. P4 is an example of someone who prefers to develop patches
with other people, since all his 10 final patches were developed with the help
of another participant. He explained this preference in the questionnaire,
saying he believed pair programming decreased the possibility of errors taking
place.  Their description of the group matches the definition given in this
work, being of an extension group that aims to help students give their first
contribution to a FLOSS project.  He also has a high proportion of patches sent
to the IIO. Of the 10 final patches he sent to FLUSP mailing list, 8 (80\%)
were sent to the former mailing list. The percentage of patches that were
accepted among the ones that were sent is similar to the majority of the studied
participants, being of 75\%.

P3 is also more opened for co-development. Although he wrote 10 (71.4\%) patches
without co-authors, 4 (28.6\%) of them were with someone else. All of his final
patches were sent to the IIO and almost all the patches sent to this mailing
list (13 of 14, or 92.9\%) were accepted and had the code merged to the official
repository.


people, since 6 of our 10 final patches (60\%) were developed this way. Another
thing that is possible to observe through the analysis of our patches is that
most of them were different versions of the same patch. This reveals our
inexperience in development, since if only the final patch versions were
considered, our number of patches would drop from 40 to 10. It is also the
reflex of our inexperience the proportion of our patches sent to the IIO, since
only 11 (27.5\%) of the total were sent to this list. Nevertheless, the
acceptance rate of our patches did not show to be much different from the other
studied participants. Of the 10 final patches sent to the IIO, 6 (75\%) of them
were accepted.

\section{Breaking barriers with FLUSP}

As for the reasons given for beginning participation in the group, the
participants have mentioned: giving and receiving help to contribute to free
software, developing research that benefits society and learning how to deal
with a large codebase.

Three of the respondents stated they always put FLUSP mailing list in copy
when sending contributions. They justified it by saying this strengthens FLUSP
as a group and increases its visibility in the FLOSS community. The only person
who said he did not put the list in copy is not actively contributing to the
kernel and is currently the mentor in another project. As such, he is the one
who reviews the patches related to this project.

The main difficulties pointed by the interviewees related to their engagement in
a FLOSS project are: not knowing where to begin or what to do, difficulty
finding documentation, and trouble understanding the source code and how it was
organized. The way those problems were mitigated varied, with two members saying
they first recurred to internet searches to try to find the solution, one member
saying his first option was the project IRC channel and another one saying he
first recurred to FLUSP. Reading documentation and the community mailing list,
and asking questions to the project maintainers were other ways those
difficulties were solved.

All of the respondents agreed that FLUSP had helped them become FLOSS
contributors. They credited the group as having rendered possible their
insertion in those communities and for teaching them how to interact with its
members. 

Three of them assessed their level of experience in the main project they
contribute to as ``little experienced''. This is a surprising result, as those
three contributors have amassed a total of 110 patches sent to FLUSP mailing
list. The respondent who assessed his level of experience in his main project as
``very experienced'' is not currently contributing to the kernel.

Lastly, there is a disagreement regarding the group structure. Although formally
FLUSP has a horizontal structure, it has been pointed out by one participant
that there is an implicit hierarchy with respect to the most experienced members
of each project. There is, according to another participant, an absence of
formalized responsibilities. This organization, or lack thereof, has been blamed
for a certain lack of autonomy of its members.
